;*******************************************************************************
; DOMAIN.SQL:   UDF-VERSION 2.3.1.143                               (21.01.2009)
;               Definition von Exceptions, Domains und UDFs
;*******************************************************************************

;*** Allgemein ***
CREATE EXCEPTION GDI_MENUES_ADMIN     'Der Menuename kann nicht gendert werden, da ihm "admin" zugeordnet ist!';
--
CREATE EXCEPTION GDI_MENUES_USED      'Dieses Menue kann nicht gelscht werden, da ihm Bediener zugeordnet sind!';
--
CREATE EXCEPTION GDI_USERTABLE_ADMIN  'Bediener "admin" darf nicht gelscht werden!';
--

;*** BLINE ***
CREATE EXCEPTION GDI_INVENTUR_DATUM   'Inventurdatum mu nach der letzten Inventur liegen!';
--
CREATE EXCEPTION GDI_INVENTUR_JAHR    'Inventurdatum liegt auerhalb des gltigen Geschftsjahres!';
--
CREATE EXCEPTION GDI_INVENTUR_ABGERECHNET 'Inventurdatum liegt im abgerechneten Zeitraum!';
--
CREATE EXCEPTION GDI_LAGER_ABGERECHNET 'Buchungsdatum liegt im abgerechneten Zeitraum!';
--
CREATE EXCEPTION GDI_ADRESSNR_INS     'Ungltige Adressnr "0" bei Belegpos-Insert!';
--
CREATE EXCEPTION GDI_ADRESSNR_UPD     'Ungltige Adressnr "0" bei Belegpos-Update!';
--
CREATE EXCEPTION GDI_ADRESSNR_DEL     'Ungltige Adressnr "0" bei Belegpos-Delete!';
--
CREATE EXCEPTION GDI_STAMMKEY_INSUPD  'Ungltiger Stammdaten-Indexeintrag "0" bei Insert oder Update!';
--
CREATE EXCEPTION GDI_BELEG_KZAUSDRUCK 'Der Beleg wurde schon ausgedruckt!';
--
CREATE EXCEPTION GDI_BELEG_KZFIBU     'Der Beleg wurde schon an die Fibu bergeben!';
--
CREATE EXCEPTION GDI_BELEG_KZABSCHL   'Der Beleg wurde schon abgeschlossen!';
--
CREATE EXCEPTION GDI_BELEG_DATUM      'Das Belegdatum liegt im abgerechneten Zeitraum!';
--
CREATE EXCEPTION GDI_ARTIKEL_STUCKL   'Dieser Artikel wird als Unterteil in einer Stckliste verwendet!';
--
CREATE EXCEPTION GDI_SHOPWGR_UNTERKNOTEN 'Diese Shop-Warengruppe enthlt Unter-Warengruppen!';
--
CREATE EXCEPTION GDI_SHOP_WGR_DELETE 'Lschen nicht mglich. Es sind untergordnete Shopwarengruppen vorhanden.';
--
CREATE EXCEPTION GDI_TREE_CICLE_NODE 'Zyklische Knotenverknpfung!';
--
CREATE EXCEPTION GDI_TREE_PARENT_NOT_FOUND 'bergeordneter Knoten nicht gefunden!';
--
CREATE EXCEPTION GDI_ARTIKEL_WEBSHOP 'Webshop- Artikel knnen nicht gelscht werden!';
--
CREATE EXCEPTION GDI_SHOPARTIKEL_DELETE 'Artikel ist als CrossSell- oder Variantenartikel zugeordnet!';
--
CREATE EXCEPTION GDI_ALTTEIL_STEUERSATZ 'Ungltiger Altteile-Steuersatz gefunden!';
--
CREATE EXCEPTION GDI_ALTTEIL_STEUERSCHL 'Gltiger Altteile-Folgesteuerschlssel fehlt!';
--

;*** FIBU ***
create Exception GDI_OP_NICHT_VORHANDEN "OP-Fehler: OP nicht vorhanden";
--
create Exception GDI_OP_WAEHRUNG "OP-Fehler: Transaktion oder Buchungswhrung falsch";
--
create Exception GDI_OP_VORHANDEN "OP-Fehler: OP bereits vorhanden";
--
create Exception GDI_OP_ZAHLUNGVORHANDEN "OP-Fehler: Zahlung bereits vorhanden";
--
create Exception GDI_OP_BELEGART "OP-Fehler: OP-Belegart unbekannt";
--
create Exception GDI_Konto_Nicht_Vorhanden "Konto nicht vorhanden";
--
create Exception GDI_Skonto_Nicht_Zulaessig "Skonto nicht zulssig";
--
create Exception GDI_Journalnr_Fehlt "Journalnummer fehlt";
--
create Exception GDI_Periode_Fehlerhaft "Periodenangabe fehlerhaft";
--
create Exception GDI_Stornofehler "Stornierung nicht mglich";
--
create Exception GDI_EbankFehler "bernahme nicht mglich (Saldo <> 0)";
--
create Exception GDI_BuchungAbgeschlossen "Die Buchung ist abgeschlossen";
--
create Exception GDI_Umsatz_Vorhanden "Umsatzwerte vorhanden";
--

;*** LOHN ***
CREATE EXCEPTION GDI_TAGZEIT_STUNDEN  'GDI Mehr als 24 Stunden erfasst';
--
CREATE EXCEPTION GDI_ZEIT_BUCHKZ      'GDI Buchungskennzeichen ist nur A,F,K,U,AG,ZG zulssig';
--
CREATE EXCEPTION GDI_ZEIT_AZMODELL    'GDI Arbeitszeitmodell nicht vorhanden';
--
CREATE EXCEPTION GDI_DEL_ZEITERF      'Historische Stundenstze drfen nicht gelscht werden!';
--

;*** ANLA ***
create Exception GDI_ANLA_STAMM "Satz 0 nicht vorhanden";
--
create Exception GDI_ANLA_BUCHUNGSART "Buchungart falsch";
--
create Exception GDI_ANLA_SATZART "Satzart falsch";
--
create Exception GDI_ANLA_DATUM "Falsches Datum";
--

CREATE DOMAIN GDI_CHAR1   AS CHARACTER (1)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR2   AS VARCHAR (2)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR3   AS VARCHAR (3)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR4   AS VARCHAR (4)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR5   AS VARCHAR (5)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR6   AS VARCHAR (6)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR7   AS VARCHAR (7)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR8   AS VARCHAR (8)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR9   AS VARCHAR (9)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR10  AS VARCHAR (10)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR11  AS VARCHAR (11)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR12  AS VARCHAR (12)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR13  AS VARCHAR (13)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR14  AS VARCHAR (14)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR15  AS VARCHAR (15)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR16  AS VARCHAR (16)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR17  AS VARCHAR (17)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR18  AS VARCHAR (18)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR19  AS VARCHAR (19)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR20  AS VARCHAR (20)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR30  AS VARCHAR (30)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR40  AS VARCHAR (40)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR50  AS VARCHAR (50)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR60  AS VARCHAR (60)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR70  AS VARCHAR (70)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR80  AS VARCHAR (80)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR90  AS VARCHAR (90)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR100 AS VARCHAR(100)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR200 AS VARCHAR(200)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR255 AS VARCHAR(255)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR400 AS VARCHAR(400)  DEFAULT '';
--
CREATE DOMAIN GDI_CHAR8000 AS VARCHAR(8000) DEFAULT '';
--
CREATE DOMAIN GDI_UUID    AS VARCHAR(36)   DEFAULT '';
--
CREATE DOMAIN GDI_SHORT   AS SMALLINT DEFAULT 0 NOT NULL;
--
CREATE DOMAIN GDI_LONG    AS INTEGER  DEFAULT 0 NOT NULL;
--
CREATE DOMAIN GDI_FLOAT   AS DOUBLE PRECISION DEFAULT 0 NOT NULL;
--
CREATE DOMAIN GDI_DATE    AS DATE;
--
CREATE DOMAIN GDI_MEMO    AS BLOB SUB_TYPE 1 SEGMENT SIZE 256;
--
CREATE DOMAIN GDI_BINARY  AS BLOB SEGMENT SIZE 256;
--

DECLARE EXTERNAL FUNCTION abs
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_abs' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION acos
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_acos' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION ascii_char
	INTEGER
	RETURNS CHAR(2) FREE_IT
	ENTRY_POINT 'IB_UDF_ascii_char' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION ascii_val
	CHAR(1)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'IB_UDF_ascii_val' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION asin
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_asin' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION atan
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_atan' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION atan2
	DOUBLE PRECISION, DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_atan2' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION bin_and
	INTEGER, INTEGER
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'IB_UDF_bin_and' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION bin_or
	INTEGER, INTEGER
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'IB_UDF_bin_or' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION bin_xor
	INTEGER, INTEGER
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'IB_UDF_bin_xor' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION ceiling
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_ceiling' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION cos
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_cos' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION cosh
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_cosh' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION cot
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_cot' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION div
	INTEGER, INTEGER
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_div' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION floor
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_floor' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION ln
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_ln' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION log
	DOUBLE PRECISION, DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_log' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION log10
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_log10' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION lower
	CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'IB_UDF_lower' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION ltrim
	CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'IB_UDF_ltrim' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION mod
	INTEGER, INTEGER
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_mod' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION pi
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_pi' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION rand
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_rand' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION rtrim
	CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'IB_UDF_rtrim' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION sign
	DOUBLE PRECISION
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'IB_UDF_sign' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION sin
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_sin' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION sinh
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_sinh' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION sqrt
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_sqrt' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION substr
	CSTRING(10000), SMALLINT, SMALLINT
	RETURNS CSTRING(80) FREE_IT
	ENTRY_POINT 'IB_UDF_substr' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION strlen
	CSTRING(32760)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'IB_UDF_strlen' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION tan
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_tan' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION tanh
	DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'IB_UDF_tanh' MODULE_NAME 'ib_udf';
--
DECLARE EXTERNAL FUNCTION BlobSize
	BLOB
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'fn_BlobSize' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION StrToBlob
   CSTRING(32760)
   RETURNS BLOB
   ENTRY_POINT 'fn_StrToBlob' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION BlobToStr
	BLOB
	RETURNS CSTRING(32760) FREE_IT
	ENTRY_POINT 'fn_BlobToStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION BlobToSubString
	BLOB, Integer, Integer
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_BlobToSubString' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION ListValue
   BLOB, CSTRING(255)
   RETURNS CSTRING(255) FREE_IT
   ENTRY_POINT 'fn_ListValue' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION ListLine
   BLOB, CSTRING(255), SMALLINT
   RETURNS CSTRING(255) FREE_IT
   ENTRY_POINT 'fn_ListLine' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION CommaTextValue
	CSTRING(10000), CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_CommaTextValue' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION ScanBlob
   BLOB, CSTRING(1000)
   RETURNS INTEGER By Value
   ENTRY_POINT 'fn_ScanBlob'  MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION BlobSubField
   BLOB, CSTRING(255), CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
   ENTRY_POINT 'fn_BlobSubField'  MODULE_NAME 'gdi_udf'
--
DECLARE EXTERNAL FUNCTION CompareText
   CSTRING(10000), CSTRING(10000)
   RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_CompareText'  MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION SubStrEx
	CSTRING(10000), Integer, Integer
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_SubStrEx' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Soundex
	CSTRING(10000)
	RETURNS CSTRING(5) FREE_IT
	ENTRY_POINT 'fn_Soundex' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION UpperCase
	CSTRING(255)
	RETURNS CSTRING(255)
	ENTRY_POINT 'fn_UpperCase' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION UpperCaseL
	CSTRING(32760)
	RETURNS CSTRING(32760)
	ENTRY_POINT 'fn_UpperCase' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION LowerCase
	CSTRING(255)
	RETURNS CSTRING(255)
	ENTRY_POINT 'fn_LowerCase' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION LowerCaseL
	CSTRING(32760)
	RETURNS CSTRING(32760)
	ENTRY_POINT 'fn_LowerCase' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Runden
	DOUBLE PRECISION, Integer
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_Runden' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DaysOfMonth
   SMALLINT, Integer
   RETURNS Integer by VALUE
   ENTRY_POINT 'fn_DaysOfMonth' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION StrToInt
	CSTRING(50)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'fn_ValToInt' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION StrToFloat
	CSTRING(50)
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_ValToDouble' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION StrToDateTime
   CSTRING(50)
   RETURNS DATE FREE_IT
   ENTRY_POINT 'fn_StrToDateTime' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION IntToStr
	Integer
	RETURNS CSTRING(50) FREE_IT
	ENTRY_POINT 'fn_IntToStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION FloatToStr
	DOUBLE PRECISION
	RETURNS CSTRING(50) FREE_IT
	ENTRY_POINT 'fn_FloatToStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DateTimeToStr
   DATE
   RETURNS CSTRING(50) FREE_IT
   ENTRY_POINT 'fn_DateTimeToStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION ReplaceStr
	CSTRING(255), CSTRING(255), CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_ReplaceStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION StrReplace
	CSTRING(255), CSTRING(255), CSTRING(255), Smallint, Smallint
	RETURNS CString(255) FREE_IT
	ENTRY_POINT 'fn_StrReplace' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Pos
	CSTRING(255), CSTRING(255)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'fn_Pos' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION PosL
	CSTRING(255), CSTRING(32760)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'fn_Pos' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Copy
	CSTRING(10000), Smallint, Smallint
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_Copy' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION CopyL
	CSTRING(32760), Smallint, Smallint
	RETURNS CSTRING(32760) FREE_IT
	ENTRY_POINT 'fn_Copy' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetYear
   DATE
	RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_GetYear' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetMonth
   DATE
	RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_GetMonth' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetDay
   DATE
	RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_GetDay' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetDayofWeek
   DATE, INTEGER
	RETURNS CSTRING(50) FREE_IT
   ENTRY_POINT 'fn_GetDayofWeek' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION WeekOfDate
   DATE
	RETURNS CSTRING(50) FREE_IT
   ENTRY_POINT 'fn_WeekOfDate' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DateOfWeek
   CSTRING(50)
	RETURNS DATE FREE_IT
   ENTRY_POINT 'fn_DateOfWeek' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetDate
   DATE
	RETURNS DATE FREE_IT
   ENTRY_POINT 'fn_GetDate' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetTime
   DATE
	RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'fn_GetTime' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetDateTime
   DATE
	RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'fn_GetDateTime' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetDateTimeStr
   CSTRING(50)
	RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'fn_GetDateTimeStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION FormatDate
	CSTRING(255), CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
   ENTRY_POINT 'fn_FormatDate' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DateToJahrMo
   DATE
	RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_DateToJahrMo' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DateStrToJahrMo
   CSTRING(50)
	RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_DateStrToJahrMo' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION JahrMoToDate
   INTEGER
	RETURNS DATE FREE_IT
   ENTRY_POINT 'fn_JahrMoToDate' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION JahrMoToDateStr
   INTEGER
	RETURNS CSTRING(50) FREE_IT
   ENTRY_POINT 'fn_JahrMoToDateStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetCommaPos
	CSTRING(10000), SMALLINT
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_GetCommaPos' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetCommaPosition
	CSTRING(10000), SMALLINT, CSTRING(1),SMALLINT
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_GetCommaPosition' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetCommaPosition2
	CSTRING(32000), SMALLINT, CSTRING(1),SMALLINT
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_GetCommaPosition' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION GetPos
	CSTRING(10000), SMALLINT, CSTRING(1)
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_GetPos' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION MaskDate
	CSTRING(255), DATE
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_MaskDate' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION MaskDouble
	CSTRING(255), DOUBLE PRECISION
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_MaskDouble' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION MaskString
	CSTRING(255), CSTRING(255)
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_MaskString' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Prozent
	DOUBLE PRECISION, DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_Prozent' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Division
	DOUBLE PRECISION, DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_Division' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Kontenbereich
	DOUBLE PRECISION, CSTRING(255),CSTRING(255)
	RETURNS CSTRING(2) FREE_IT
	ENTRY_POINT 'fn_Kontenbereich' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION SHSoll
	CSTRING(255), DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_SHSoll' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION SHHaben
	CSTRING(255), DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_SHHaben' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION SHBetrag
	CSTRING(255), DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_SHBetrag' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION SHBetragExt
	CSTRING(255), DOUBLE PRECISION, CSTRING(255), CSTRING(255)
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_SHBetragExt' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION KstBetragVerteilen
	CSTRING(10000), DOUBLE PRECISION
	RETURNS CSTRING(10000) FREE_IT
	ENTRY_POINT 'fn_KstBetragVerteilen' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION KstToAufteilung
	DOUBLE PRECISION, DOUBLE PRECISION, DOUBLE PRECISION, DOUBLE PRECISION, CSTRING(40)
	RETURNS CSTRING(10000) FREE_IT
	ENTRY_POINT 'fn_KstToAufteilung' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION KstToAufteilung2
	DOUBLE PRECISION, DOUBLE PRECISION, DOUBLE PRECISION, DOUBLE PRECISION, DOUBLE PRECISION, CSTRING(40)
	RETURNS CSTRING(10000) FREE_IT
	ENTRY_POINT 'fn_KstToAufteilung2' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION KstMengenStorno
   CSTRING(10000)
   RETURNS CSTRING(10000) FREE_IT
   ENTRY_POINT 'fn_KstMengenStorno' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Trim
   CSTRING(255)
   RETURNS CSTRING(255) FREE_IT
   ENTRY_POINT 'fn_Trim' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Trim2
   CSTRING(255)
   RETURNS CSTRING(255) FREE_IT
   ENTRY_POINT 'fn_Trim' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION TrimL
   CSTRING(32760)
   RETURNS CSTRING(32760) FREE_IT
   ENTRY_POINT 'fn_Trim' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION CrLf
	INTEGER
	RETURNS CSTRING(255) FREE_IT
	ENTRY_POINT 'fn_CrLf' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Ascii_Char2
	INTEGER
	RETURNS CHAR(2) FREE_IT
	ENTRY_POINT 'fn_Ascii_Char2' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION IsInteger
	CSTRING(255)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'fn_IsInteger' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION IsFloat
	CSTRING(255)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'fn_IsFloat' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION IsDate
	CSTRING(255)
	RETURNS INTEGER BY VALUE
	ENTRY_POINT 'fn_IsDate' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Version
   CSTRING(255)
   RETURNS CSTRING(255) FREE_IT
   ENTRY_POINT 'fn_Version' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DiskFree
   CSTRING(255)
   RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'fn_DiskFree' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DiskSize
   CSTRING(255)
   RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'fn_DiskSize' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Ablauf_Tag
   Date, Integer, Integer, Integer, Integer
   RETURNS DATE FREE_IT
   ENTRY_POINT 'fn_Ablauf_Tag' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Buchungssumme
	CSTRING(1), DOUBLE PRECISION, DOUBLE PRECISION, DOUBLE PRECISION, DOUBLE PRECISION
	RETURNS DOUBLE PRECISION BY VALUE
	ENTRY_POINT 'fn_Buchungssumme' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION UUIDStr
   RETURNS CSTRING(36) FREE_IT
   ENTRY_POINT 'fn_UUIDStr' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DayOfTheMonth
   DATE
   RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_DayOfTheMonth' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION DayOfTheWeek
   DATE
   RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_DayOfTheWeek' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION TimeStampToFloat
   DATE 
	RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'fn_TimeStampToFloat' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION FloatToTimeStamp
   DOUBLE PRECISION
   RETURNS DATE FREE_IT
   ENTRY_POINT 'fn_FloatToTimeStamp' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION SecondsBetween
   DATE, DATE
   RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_SecondsBetween' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Trunc
   DOUBLE PRECISION
   RETURNS INTEGER BY VALUE
   ENTRY_POINT 'fn_Trunc' MODULE_NAME 'gdi_udf';
--
DECLARE EXTERNAL FUNCTION Frac
   DOUBLE PRECISION
   RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'fn_Frac' MODULE_NAME 'gdi_udf';
--

